<template>
  <v-list nav dense>
    <new-analysis-button
      @replace-analysis="$emit('replace-analysis', $event)"
    />
    <analysis-nav-list
      :analyses-list="analysesList"
      :is-minified="isMinified"
    />
    <analysis-external-services
      :analysis="analysis"
      :client="client"
      :piece-path="piecePath"
      @replace-analysis="$emit('replace-analysis', $event)"
    />
    <upload-button
      v-if="piece && canUploadAnalysis"
      :client="client"
      :piece-path="piecePath"
      :analysis="analysis"
      :clean.sync="isClean"
      @reload-analyses="loadAnalyses"
    />
    <import-button
      @replace-analysis="$emit('replace-analysis', $event)"
    />
    <export-button
      :clean.sync="isClean"
      :analysis="analysis"
      :piece-path="piecePath"
    />
    <synchro-edit-button
      v-if="canEditSync"
    />
  </v-list>
</template>

<script lang="ts">
import {
  Vue, Component, Watch, Prop, PropSync,
} from 'vue-property-decorator';
import type { Client } from '@/client';
import type { Analysis, Piece } from '@/data';
import SynchroEditButton from '@/components/navigation/buttons/SynchroEditButton.vue';
import UploadButton from './UploadButton.vue';
import ExportButton from './ExportButton.vue';
import ImportButton from './ImportButton.vue';
import NewAnalysisButton from './NewAnalysisButton.vue';
import AnalysisNavList from './AnalysisNavList.vue';
import AnalysisExternalServices from './AnalysisExternalServices.vue';

@Component({
  components: {
    UploadButton,
    ExportButton,
    ImportButton,
    NewAnalysisButton,
    AnalysisNavList,
    SynchroEditButton,
    AnalysisExternalServices,
  },
})
export default class AnalysisSidebarItems extends Vue {
  analysesList: string[] = [];

  @Prop({ required: true })
  client!: Client;

  @Prop({ required: true })
  piecePath!: string;

  @Prop({ required: true })
  analysis!: Analysis | null;

  @Prop({ default: false })
  isMinified!: boolean;

  @Prop({ required: true })
  canEditSync!: boolean;

  @Prop({ required: true })
  piece!: Piece | null;

  @PropSync('clean')
  isClean!: boolean;

  canUploadAnalysis = false;

  mounted() {
    this.loadAnalyses();
  }

  @Watch('piecePath')
  onRoute() {
    this.analysesList = [];
    this.loadAnalyses();
  }

  async loadAnalyses() {
    const currentPath = this.piecePath;
    const analysesListRes = await this.client.loadAnalysesList(currentPath);
    // Throws if req failed
    const analysesList = analysesListRes.data;
    const noEmptyList = analysesList.filter((id) => id !== 'empty.dez');

    if (currentPath === this.piecePath) this.analysesList = noEmptyList;
  }

  @Watch('piece')
  canUpload() {
    if (this.piece) {
      this.canUploadAnalysis = this.piece.can('update-analysis');
    } else {
      this.canUploadAnalysis = false;
    }
  }
}

</script>
